=== debian/changelog ===
gnuplot (5.2.2+dfsg1-2ubuntu1) bionic; urgency=medium
 
  * Restore Provides/Breaks/Replaces needed for upgrades from xenial
    (LP: #1754577).  This can be dropped after the bionic release.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 03 Apr 2018 16:51:18 +0100

gnuplot (5.2.2+dfsg1-2) unstable; urgency=medium

  * [0bc35ea] Fix installation of non-arch files. (Closes: #881223)

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Nov 2017 05:40:21 +0100

gnuplot (5.2.2+dfsg1-1) unstable; urgency=medium

  * [d1fb5bb] Update d/copyright
  * [e346cfa] Update d/watch
  * [9c49e48] New upstream version 5.2.2+dfsg1
  * [133babd] Refresh patches

 -- Anton Gladky <gladk@debian.org>  Wed, 08 Nov 2017 21:00:44 +0100
